package kse.clientServer;

import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author Milos Novacek
 */
public class Server {

    private Set<IClient> registeredClients = new HashSet<IClient>();
    private IDate today;

    public void setDate(IDate date) throws IllegalArgumentException {
        if (date == null) {
            throw new IllegalArgumentException("the date can not be null");
        }
        today = date;
    }

    public void register(IClient client) {
        this.registeredClients.add(client);
    }

    public void deregister(IClient client) {
        this.registeredClients.remove(client);
    }

    // Be carefull not to send a message to the sender.
    public void send(IClient sender, String message) {
        for (IClient c : this.registeredClients) {
            if (c != sender && !c.isIgnored(sender)) {
                try {
                    c.receive(sender, message);
                } catch (IllegalArgumentException e) {
                    // we do nothing
                }
            }
        }
    }

    public void wishHappyBirthday() {
        for (IClient c : this.registeredClients) {
            IDate cBDate = c.getBirthday();
            if (cBDate.getDay() == today.getDay() && cBDate.getMonth() == today.getMonth()) {
                c.receiveSystemMessage("Happy Birthday!!!");
            }
        }
    }
}
