
import java.awt.TextArea;
import java.util.List;

public class FormattedTextArea extends TextArea {

    // paragraph that contains the formated text
    private Paragraph paragraph;
    private Counter counter;

    public void setFormatter(Formatter f) {
        paragraph.setFormater(f);
        this.setText(getText());
    }

    public FormattedTextArea() {
        counter = new Counter();
        paragraph = new Paragraph(counter);
    }

    /**
     * Return the aligned text.
     */
    @Override
    public String getText() {
        List<String> l = paragraph.alignedText();
        String result = "";
        for (String s : l) {
            result += s + "\n";
        }
        return result;
    }

    /**
     * Add a new line.
     */
    @Override
    public void append(String str) {
        paragraph.addLine(str);
        super.setText(getText());
    }

    public int numberOfCharacters() {
        return counter.getCounter();
    }
}
