package refactoringsolution;

import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Arsenii
 */
public class DiagonalMatrixTest {

    private final int n = 2;
    private DiagonalMatrix dm1, dm2, dm3;
    private FullMatrix fm1, fm2;

    @Before
    public void setUp() {
        dm1 = new DiagonalMatrix(n);
        for (int i = 0; i < n; i++) {
            dm1.set(i, i, i + 1);
        }

        dm2 = new DiagonalMatrix(n);
        for (int i = 0; i < n; i++) {
            dm2.set(i, i, i - 1);
        }

        dm3 = new DiagonalMatrix(n);
        for (int i = 0; i < n; i++) {
            dm3.set(i, i, 2 * i);
        }

        fm1 = new FullMatrix(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                fm1.set(i, j, i == j ? i - 1 : 0.);
            }
        }

        fm2 = new FullMatrix(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                fm2.set(i, j, i == j ? 2 * i : 0.);
            }
        }

    }

    /**
     * Test of set and get methods, of class DiagonalMatrix.
     */
    @Test
    public void testSetGet() {


        DiagonalMatrix m = new DiagonalMatrix(n);

        for (int i = 0; i < n; i++) {
            m.set(i, i, i + 1);
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                assertSame("DiagonalMatrix.get or  DiagonalMatrix.set error",
                        Double.compare(m.get(i, j), i == j ? i + 1 : 0.), 0);
            }
        }


    }

    /**
     * Test of get method, of class DiagonalMatrix.
     */
    @Test(expected = AssertionError.class)
    public void testGetFail() {
        dm1.set(0, 1, 1);

    }

    /**
     * Test of add method, of class DiagonalMatrix.
     */
    @Test
    public void testAddD() {
        assertEquals("DiagonalMatrix.Add error", dm1.add(dm2), dm3);
    }

    /**
     * Test of add method, of class DiagonalMatrix.
     */
    @Test
    public void testAddF() {
        assertEquals("DiagonalMatrix.Add error", dm1.add(fm1), fm2);
    }

    /**
     * Test of addDiagonal method, of class DiagonalMatrix.
     */
    @Test
    public void testAddDiagonal() {
        assertEquals("DiagonalMatrix.AddDiagonal error", dm1.addDiagonal(dm2), dm3);
    }

    /**
     * Test of addFull method, of class DiagonalMatrix.
     */
    @Test
    public void testAddFull() {
        assertEquals("DiagonalMatrix.AddFull error", dm1.addFull(fm1), fm2);
    }

    @Test(expected = AssertionError.class)
    public void testAddFail() {
        new DiagonalMatrix(1).add(new DiagonalMatrix(2));
    }
}
