package refactoringsolution;

import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Arsenii
 */
public class FullMatrixTest {

    private final int n = 2;
    private DiagonalMatrix dm1;
    private FullMatrix fm1, fm2, fm3, fm4;

    @Before
    public void setUp() {

        fm1 = new FullMatrix(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                fm1.set(i, j, i + j);
            }
        }

        fm2 = new FullMatrix(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                fm2.set(i, j, 2 * (i + j));
            }
        }

        fm3 = new FullMatrix(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                fm3.set(i, j, 3 * (i + j));
            }
        }

        fm4 = new FullMatrix(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                fm4.set(i, j, i == j ? 3 * i : i + j);
            }
        }

        dm1 = new DiagonalMatrix(n);
        for (int i = 0; i < n; i++) {
            dm1.set(i, i, i);
        }

    }

    /**
     * Test of set and get methods, of class FullMatrix.
     */
    @Test
    public void testSetGet() {


        FullMatrix m = new FullMatrix(n);

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                m.set(i, j, i + j);
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                assertSame("DiagonalMatrix.get or  DiagonalMatrix.set error",
                        Double.compare(m.get(i, j), i + j), 0);
            }
        }


    }

    /**
     * Test of add method, of class FullMatrix.
     */
    @Test
    public void testAddD() {
        assertEquals("FullMatrix.Add error", fm1.add(dm1), fm4);
    }

    /**
     * Test of add method, of class FullMatrix.
     */
    @Test
    public void testAddF() {
        assertEquals("FullMatrix.Add error", fm1.add(fm2), fm3);
    }

    /**
     * Test of addDiagonal method, of class FullMatrix.
     */
    @Test
    public void testAddDiagonal() {
        assertEquals("FullMatrix.AddDiagonal error", fm1.addDiagonal(dm1), fm4);
    }

    /**
     * Test of addFull method, of class FullMatrix.
     */
    @Test
    public void testAddFull() {
        assertEquals("FullMatrix.AddFull error", fm1.addFull(fm2), fm3);
    }

    @Test(expected = AssertionError.class)
    public void testAddFail() {
        new FullMatrix(1).add(new FullMatrix(2));
    }
}
