package refactoringsolution;

import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author Arsenii
 */
public class MatrixTest {

    private final int n = 2;
    private Matrix m;

    @Before
    public void setUp() {
        m = new FullMatrix(n);
    }

    @Test
    public void testNotEqualsMatixToString() {
        assertFalse("Matrix.Equals error", ((Matrix) new FullMatrix(1)).equals("Matrix"));
    }

    @Test
    public void testNotEqualDifferentSize() {
        assertFalse("Matrix.equals error", ((Matrix) new DiagonalMatrix(1)).equals(new DiagonalMatrix(2)));
    }

    @Test
    public void testGetSet() {
        m.set(1, 1, 5);
        assertEquals(5.0d, m.get(1, 1), 0.0001);
    }

    @Test
    public void testToString() {
        for (int i = 0; i < n; i++) {
            m.set(i, i, 2 * i);
        }
        String s1 = "[ 0.0 0.0]\n[ 0.0 2.0]\n";
        String s2 = m.toString();
        assertEquals("Matrix.toString error", s1, s2);
    }

    @Test
    public void testHashCode() {
        Set<Matrix> set = new HashSet<Matrix>();
        final int size = 10;

        for (int i = 1; i <= size; i++) {
            set.add(new FullMatrix(3));
        }

        assertEquals("Matrix.hashCode error", 1, set.size());
    }
}
