package Client;

import java.rmi.RemoteException;
import java.rmi.NotBoundException;
import java.rmi.server.UnicastRemoteObject;
import java.io.*;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

import Server.IServerInterface;

public class ClientImpl extends UnicastRemoteObject implements IClientInterface {

    private IServerInterface server;

    public ClientImpl() throws RemoteException {
    }

    public void getMessage(String str) throws RemoteException {
        System.out.println(str);
    }

    private void connect() {
        try {
            Registry rmi = LocateRegistry.getRegistry(IServerInterface.PORT);
            server = (IServerInterface) rmi.lookup(IServerInterface.LOOKUP_NAME);
            server.register(this);
        } catch (NotBoundException e) {
            System.err.println("Failed to connect to server service: " + e.getMessage());
        } catch (RemoteException e) {
            System.err.println("Connection error: " + e.getMessage());
        }
    }

    private void run() {
        String str;
        BufferedReader ir = new BufferedReader(new InputStreamReader(System.in));

        while (true) {
            try {
                System.out.println("Enter a message sometime...");
                str = ir.readLine();
                server.sendMessage(this, str);
            } catch (Exception e) {
                System.err.println("Failed to send message: " + e.getMessage());
            }
        }

    }

    public static void main(String[] args) {
        try {
            ClientImpl client = new ClientImpl();
            client.connect();
            client.run();
        } catch (Exception e) {
            System.err.println("Failed to start client: " + e.getMessage());
        }
    }
}
